#include <math.h>
#include <stdio.h>
#include <dos.h>
#include <windows.h>
#include "tiepie.h"
#include "mex.h"
#define _DEBUG

void InitFunctions( HINSTANCE MyDLL ) {

	InitInstrument = GetProcAddress(MyDLL,"InitInstrument");
	ExitInstrument = GetProcAddress(MyDLL,"ExitInstrument");

	GetCalibrationDate = GetProcAddress(MyDLL,"GetCalibrationDate");
	GetSerialNumber = GetProcAddress(MyDLL,"GetSerialNumber");

	GetMaxSampleFrequency = GetProcAddress(MyDLL,"GetMaxSampleFrequency");
	GetMaxRecordLength = GetProcAddress(MyDLL,"GetMaxRecordLength");

	GetSquareWaveGenStatus = GetProcAddress(MyDLL,"GetSquareWaveGenStatus");
	GetFunctionGenStatus = GetProcAddress(MyDLL,"GetFunctionGenStatus");
	GetFuncGenMaxAmplitude = GetProcAddress(MyDLL,"GetFuncGenMaxAmplitude");
	
	StartMeasurement = GetProcAddress(MyDLL,"StartMeasurement");

	GetMeasurement = GetProcAddress(MyDLL,"GetMeasurement");
	GetOneMeasurement = GetProcAddress(MyDLL,"GetOneMeasurement");
	
	GetMeasurementRaw = GetProcAddress(MyDLL,"GetMeasurementRaw");
	GetOneMeasurementRaw = GetProcAddress(MyDLL,"GetOneMeasurementRaw");
	
	GetDigitalInputValues = GetProcAddress(MyDLL,"GetDigitalInputValues");
	GetOneDigitalValue = GetProcAddress(MyDLL,"GetOneDigitalValue");
	
	GetMeasureMode = GetProcAddress(MyDLL,"GetMeasureMode");
	SetMeasureMode = GetProcAddress(MyDLL,"SetMeasureMode");
	
	GetRecordLength = GetProcAddress(MyDLL,"GetRecordLength");
	SetRecordLength = GetProcAddress(MyDLL,"SetRecordLength");
	
	GetPostSamples = GetProcAddress(MyDLL,"GetPostSamples");
	SetPostSamples = GetProcAddress(MyDLL,"SetPostSamples");
	
	GetSampleFrequency = GetProcAddress(MyDLL,"GetSampleFrequency");
	SetSampleFrequency = GetProcAddress(MyDLL,"SetSampleFrequency");
	
	GetSensitivity = GetProcAddress(MyDLL,"GetSensitivity");
	SetSensitivity = GetProcAddress(MyDLL,"SetSensitivity");

	GetAutoRanging = GetProcAddress(MyDLL,"GetAutoRanging");
	SetAutoRanging = GetProcAddress(MyDLL,"SetAutoRanging");
	
    GetCoupling = GetProcAddress(MyDLL,"GetCoupling");
	SetCoupling = GetProcAddress(MyDLL,"SetCoupling");

	GetDcLevel = GetProcAddress(MyDLL,"GetDcLevel");
	SetDcLevel = GetProcAddress(MyDLL,"SetDcLevel");
	
	GetTriggerSource = GetProcAddress(MyDLL,"GetTriggerSource");
	SetTriggerSource = GetProcAddress(MyDLL,"SetTriggerSource");
	
    GetTriggerMode = GetProcAddress(MyDLL,"GetTriggerMode");
	SetTriggerMode = GetProcAddress(MyDLL,"SetTriggerMode");

	GetTriggerLevel = GetProcAddress(MyDLL,"GetTriggerLevel");
	SetTriggerLevel = GetProcAddress(MyDLL,"SetTriggerLevel");
	
	GetTriggerHys = GetProcAddress(MyDLL,"GetTriggerHys");
	SetTriggerHys = GetProcAddress(MyDLL,"SetTriggerHys");
	
	SetPXITriggerEnables = GetProcAddress(MyDLL,"SetPXITriggerEnables");
	GetPXITriggerEnables = GetProcAddress(MyDLL,"GetPXITriggerEnables");
	
	SetPXITriggerSlopes = GetProcAddress(MyDLL,"SetPXITriggerSlopes");
	GetPXITriggerSlopes = GetProcAddress(MyDLL,"GetPXITriggerSlopes");
	
	GetTriggerTimeOut = GetProcAddress(MyDLL,"GetTriggerTimeOut");
	SetTriggerTimeOut = GetProcAddress(MyDLL,"SetTriggerTimeOut");
	
	SetDigitalOutputs = GetProcAddress(MyDLL,"SetDigitalOutputs");
	GetDigitalOutputs = GetProcAddress(MyDLL,"GetDigitalOutputs");

	GetSquareWaveGenFrequency = GetProcAddress(MyDLL,"GetSquareWaveGenFrequency");
	SetSquareWaveGenFrequency = GetProcAddress(MyDLL,"SetSquareWaveGenFrequency");

	SetFuncGenSignalType = GetProcAddress(MyDLL,"SetFuncGenSignalType");
	GetFuncGenSignalType = GetProcAddress(MyDLL,"GetFuncGenSignalType");

	SetFuncGenAmplitude = GetProcAddress(MyDLL,"SetFuncGenAmplitude");
	GetFuncGenAmplitude = GetProcAddress(MyDLL,"GetFuncGenAmplitude");

	SetFuncGenDCOffset = GetProcAddress(MyDLL,"SetFuncGenDCOffset");
	GetFuncGenDCOffset = GetProcAddress(MyDLL,"GetFuncGenDCOffset");

	SetFuncGenSymmetry = GetProcAddress(MyDLL,"SetFuncGenSymmetry");
	GetFuncGenSymmetry = GetProcAddress(MyDLL,"GetFuncGenSymmetry");

	SetFuncGenFrequency = GetProcAddress(MyDLL,"SetFuncGenFrequency");
	GetFuncGenFrequency = GetProcAddress(MyDLL,"GetFuncGenFrequency");

	FillFuncGenMemory = GetProcAddress(MyDLL,"FillFuncGenMemory");
	GetFuncGenOutputOn = GetProcAddress(MyDLL,"GetFuncGenOutputOn");
}


/*
numoutput = number of output arguments
*output = pointer to array of pointers to output matrices (confusing eh? ;)
numinput = number of input arguments
*input = pointer to array of pointers to input matrices
*/
void mexFunction( int numoutput, mxArray *output[],
		  int numinput, const mxArray*input[] )
{
    HINSTANCE HS3DLL;                 // handle for DLL

	unsigned int serial, i;
	unsigned short int errcode;
	dword caldate;
	unsigned int day,month,year;
	double *CH1_data;
	double *CH2_data;
	double *tempval;
	dword RecordLength;
	unsigned int SampleFrequency;
	double CH1_Sens;
	double CH2_Sens;

	if ( !(HS3DLL = LoadLibrary("hs3_m.dll"))) {
	mexErrMsgTxt("Failed to load library hs3_m.dll\n");
	}

	InitFunctions(HS3DLL);
	errcode = InitInstrument(0);
	if ( errcode != E_NO_ERRORS ) {
	    mexErrMsgTxt("ERROR : Device HS3 not found!!\n");
	    return;
	}


    /* Check for number of input arguments */
    if (numinput != 4) {
		mexPrintf("Four input arguments required for measurements : \n >>mex_hs3(samplefreq,#samples"
      ",sensitivity1,sensitivity2)\n");
   	    ExitInstrument();
    		 FreeLibrary(HS3DLL);
   	    return;
    }

	tempval = mxGetPr(input[0]);
	SampleFrequency = (unsigned int) *tempval;
	tempval = mxGetPr(input[1]);
	RecordLength = (unsigned short int) *tempval;
	tempval = mxGetPr(input[2]);
	CH1_Sens = *tempval;
	tempval = mxGetPr(input[3]);
	CH2_Sens = *tempval;


    if ( SampleFrequency > 100000000 ) {
        mexErrMsgTxt("ERROR : Sample frequency requested is not supported by the connected device!! [HS3]\n");
        return;
    }

    errcode = SetRecordLength(RecordLength);
    if ( errcode != E_NO_ERRORS ) {
        mexPrintf("ERRORCODE : 0x%xh\t%d\n", errcode, RecordLength);
        mexErrMsgTxt("ERROR : SetRecordLength(RecordLength)\n");
        }
	errcode = SetSampleFrequency(&SampleFrequency);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetSampleFrequency(&SampleFrequency)\n");

	/* All sampling after trigger should be measured */
	errcode = SetPostSamples(RecordLength);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetPostSamples(RecordLength)\n");

	/* Coupling : DC */
	errcode = SetCoupling(1,0);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetCoupling(1,0)\n");
	errcode = SetCoupling(2,0);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetCoupling(2,0)\n");

	/* Mode : CH1 & CH2 */
	if ( SampleFrequency == 100000000 ) {
		errcode = SetMeasureMode(1);
      if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetMeasureMode(1)\n");
	}
	else {
	    SetMeasureMode(3);
       if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetMeasureMode(3)\n");
	}


	/* Autoranging : OFF */
	errcode = SetAutoRanging(1,0);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetAutoRanging(1,0)\n");
	errcode = SetAutoRanging(2,0);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetAutoRanging(2,0)\n");

	/* No Trigger, measure immediately */
	errcode = SetTriggerSource(5);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetTriggerSource(5)\n");

	/* set sensitivities */
	errcode = SetSensitivity(1, &CH1_Sens);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetSensitivity(1, &CH!_Sens)\n");
	SetSensitivity(2, &CH2_Sens);
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : SetSensitivity(2, &CH2_Sens)\n");

	/* start measurement */
	errcode = StartMeasurement();
    if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : StartMeasurement()\n");

    /* Put measurement-data in output-matrix	 */
	output[0] = mxCreateDoubleMatrix(RecordLength,2,mxREAL);
	CH1_data = mxGetPr(output[0]);
	CH2_data = mxGetPr(output[0]) + RecordLength;
	errcode = GetMeasurement(CH1_data,CH2_data);
   if ( errcode != E_NO_ERRORS ) mexErrMsgTxt("ERROR : GetMeasurement(CH1_data, CH2_data)\n");


	ExitInstrument();
	FreeLibrary(HS3DLL);
   return;
}
